(*
  Copyright 2010 Gerd Stolpmann

  This file is part of Plasma, a distributed filesystem and a
  map/reduce computation framework. Unless you have a written license
  agreement with the copyright holder (Gerd Stolpmann), the following
  terms apply:

  Plasma is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Plasma is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

*)
(* $Id: mapred_def.ml 239 2010-06-23 16:49:03Z gerd $ *)

class type mapred_env =
object
  method open_cluster : Unixqueue.event_system -> Plasma_client.plasma_cluster
  method config_file : Netplex_types.config_file
  method arguments : string array
end


class type mapred_job =
object
  method name : string
  method input_dir : string
  method output_dir : string
  method work_dir : string
  method check_config : mapred_env -> unit
  method map : mapred_env -> int -> Mapred_io.record_reader -> Mapred_io.record_writer -> unit
  method map_tasks : int
  method sort_limit : int64
  method merge_limit : int
  method split_limit : int
  method extract_key : mapred_env -> string -> string
  method partitions : int
  method partition_of_key : mapred_env -> string -> int
  method reduce : mapred_env -> int -> Mapred_io.record_reader -> Mapred_io.record_writer -> unit
end
